--- Query 1 -- Länge Tour Simple ---
CREATE OR REPLACE VIEW TourG AS
   SELECT tid, SUM(gebuehr) AS gebuehr FROM TourAnkerplatz ta JOIN Hafen h ON ta.krz = h.krz GROUP BY tid;
   
SELECT * FROM TourG;


--- Query 2 -- Länge einer Tour ---
CREATE OR REPLACE VIEW TourGebuehr AS
WITH RECURSIVE tmp(tid,teilvon,gebuehr) AS (
      SELECT tg.tid, teilvon, gebuehr FROM TourG tg JOIN Teiltour tt ON tg.tid = tt.tid
   UNION
      SELECT tmp.tid, tt.teilvon, tmp.gebuehr FROM tmp JOIN Teiltour tt ON tmp.teilvon = tt.tid
) SELECT tg.tid, COALESCE(SUM(tmp.gebuehr),0)+tg.gebuehr as gebuehr 
   FROM tmp RIGHT JOIN TourG tg ON tmp.teilvon=tg.tid 
   GROUP BY tg.tid, tg.gebuehr;
   
SELECT * FROM TourGebuehr;
